/*
 * masschroqDomDocument.h
 *
 *  Created on: 18 sept. 2012
 *      Author: valot
 */

#ifndef MASSCHROQDOMDOCUMENT_H_
#define MASSCHROQDOMDOCUMENT_H_

#include "../../lib/alignments/alignment_ms2.h"
#include "../../lib/alignments/alignment_obiwarp.h"
#include <QDomDocument>
#include <QDomElement>
#include <pappsomspp/xic/detection/xicdetectionzivy.h>
#include <pappsomspp/xic/filters/xicfilterbackground.h>
#include <pappsomspp/xic/filters/xicfilterspike.h>

class MasschroqDomDocument {
public:
  MasschroqDomDocument();
  virtual ~MasschroqDomDocument();

  void newQuantificationMethod();
  void addExtractionMethod(pappso::XicExtractMethod, pappso::PrecisionP min,
                           pappso::PrecisionP max);
  void addBackgroundFilterMethod(const pappso::XicFilterBackground &filter);
  void addSpikeFilterMethod(const pappso::XicFilterSpike &filter);
  void addDetectionZivyMethod(const pappso::XicDetectionZivy &detect);
  bool verifyQuantificationMethod();

  void newAlignementMethod();
  void addObiwarpMethod(const AlignmentObiwarp &align);
  void addMs2AlignmentMethod(const AlignmentMs2 &align);

  QString getXMLString() const;

private:
  QDomDocument _dom;
  QDomElement _quantimethod;
  QDomElement _alignmethod;
};

#endif /* MASSCHROQDOMDOCUMENT_H_ */
