/*
 * treatment_box_xic_filter.cpp
 *
 *  Created on: 21 mai 2012
 *      Author: valot
 */

#include "treatment_box_xic_filter.h"
#include "../../lib/xic/xic_base.h"

TreatmentBoxXicFilter::TreatmentBoxXicFilter(const TreatmentChain &chain)
    : TreatmentBox(chain) {
  _p_filter = nullptr;
}

TreatmentBoxXicFilter::~TreatmentBoxXicFilter() {}

void TreatmentBoxXicFilter::setFilter(pappso::XicFilterInterface *filter) {
  if (filter != nullptr) {
    _p_filter = filter;
    this->updatedAndEmitChanged();
  }
}

void TreatmentBoxXicFilter::doTreatment() {
  qDebug() << "Do filter treatment";
  if ((this->getPrevious() != nullptr) &&
      (this->getPrevious()->getCurrentXic() != nullptr)) {
    _current_xic_sp = this->getPrevious()->getCurrentXic();
    if (_p_filter != nullptr) {

      pappso::NoConstXicSp sp_newxic = pappso::Xic().makeNoConstXicSp();

      _p_filter->filter(*(_current_xic_sp.get()), sp_newxic.get());

      _current_xic_sp = sp_newxic;
      //_currentXic->toStream(cout);
      emit changedXic(this);
    }
  }
}
